︠b2b2e130-69bd-46ee-a0cc-33282980c6abi︠
%html
<p><strong><span style="color: #ff0000;">KIES EERST HIERBOVEN "Action" OPTIE "Evaluate All"</span></strong></p>
<p>&nbsp;</p>
<p><strong><span style="font-size: x-large; color: #339966;">Uitleg ABC algoritme</span></strong></p>
<p>De opzet is overgenomen van <a href="http://www.rekenmeemetabc.nl/artikel/28/Algoritme">Reken mee met ABC</a>:</p>
<ul>
<li>een groot getal NN wordt genomen</li>
<li>in 5 stappen wordt getracht alle ABC-triples te vinden met radiaal kleiner dan NN</li>
<li>men gebruikt het feit dat radiaal(A), radiaal(B) en radiaal(C) verschillende getallen zijn!</li>
<li>dat maakt dat je deze drie radiaal-getallen in volgorde kunt plaatsen: r(x)&lt;r(y)&lt;r(z)</li>
<li>waaruit direct volgt dat 1 &lt; r(y) &lt; sqrt(NN) en r(x) &lt; NN/r(y)^2.</li>
</ul>
<p>De 5 stappen zijn:</p>
<ol style="list-style-type: lower-roman;">
<li>bij het getal NN bepaal alle mogelijke waarden voor r(y)</li>
<li>bij de waarden r(y) bepaal alle mogelijke waarden voor y</li>
<li>bij de waarden r(y) bepaal alle mogelijke waarden voor r(x)</li>
<li>bij de waarden r(x) bepaal alle mogelijke waarden voor x</li>
<li>bij elke waarde van x en y zijn er twee mogelijke uitkomsten:&nbsp;{x,y,c=x+y} of {|x-y|,min(x,y),max(x,y)}</li>
</ol>
<p>Tenslotte gaan we na of de gevonden drietallen ABC-triples zijn.</p>
<p><br /> <strong>Gebruik deze link <a href="#start">hier</a> om abc-triples te zoeken</strong></p>
<p>&nbsp;</p>
<p><strong><span style="font-size: large; color: #339966;">Uitbreiding</span></strong></p>
<p>Een slimme uitbreiding is om elk relatie A+B=C te vermenigvuldigen met respectievelijk (C+A), (C+B) of (B-A). Dat geeft de volgende kansrijke drietallen:</p>
<ul>
<li>A<sup>2</sup>+B*(C+A)=C<sup>2</sup></li>
<li>B<sup>2</sup>+A*(C+B)=C<sup>2</sup></li>
<li>A<sup>2</sup>+C*(B-A)=B<sup>2</sup></li>
</ul>
<p>Als je wilt, worden ook deze drietallen worden doorgerekend.</p>

︡30a1de3d-2076-44c6-a659-49e8ccfd36e6︡{"html": "<p><strong><span style=\"color: #ff0000;\">KIES EERST HIERBOVEN \"Action\" OPTIE \"Evaluate All\"</span></strong></p>\n<p>&nbsp;</p>\n<p><strong><span style=\"font-size: x-large; color: #339966;\">Uitleg ABC algoritme</span></strong></p>\n<p>De opzet is overgenomen van <a href=\"http://www.rekenmeemetabc.nl/artikel/28/Algoritme\">Reken mee met ABC</a>:</p>\n<ul>\n<li>een groot getal NN wordt genomen</li>\n<li>in 5 stappen wordt getracht alle ABC-triples te vinden met radiaal kleiner dan NN</li>\n<li>men gebruikt het feit dat radiaal(A), radiaal(B) en radiaal(C) verschillende getallen zijn!</li>\n<li>dat maakt dat je deze drie radiaal-getallen in volgorde kunt plaatsen: r(x)&lt;r(y)&lt;r(z)</li>\n<li>waaruit direct volgt dat 1 &lt; r(y) &lt; sqrt(NN) en r(x) &lt; NN/r(y)^2.</li>\n</ul>\n<p>De 5 stappen zijn:</p>\n<ol style=\"list-style-type: lower-roman;\">\n<li>bij het getal NN bepaal alle mogelijke waarden voor r(y)</li>\n<li>bij de waarden r(y) bepaal alle mogelijke waarden voor y</li>\n<li>bij de waarden r(y) bepaal alle mogelijke waarden voor r(x)</li>\n<li>bij de waarden r(x) bepaal alle mogelijke waarden voor x</li>\n<li>bij elke waarde van x en y zijn er twee mogelijke uitkomsten:&nbsp;{x,y,c=x+y} of {|x-y|,min(x,y),max(x,y)}</li>\n</ol>\n<p>Tenslotte gaan we na of de gevonden drietallen ABC-triples zijn.</p>\n<p><br /> <strong>Gebruik deze link <a href=\"#start\">hier</a> om abc-triples te zoeken</strong></p>\n<p>&nbsp;</p>\n<p><strong><span style=\"font-size: large; color: #339966;\">Uitbreiding</span></strong></p>\n<p>Een slimme uitbreiding is om elk relatie A+B=C te vermenigvuldigen met respectievelijk (C+A), (C+B) of (B-A). Dat geeft de volgende kansrijke drietallen:</p>\n<ul>\n<li>A<sup>2</sup>+B*(C+A)=C<sup>2</sup></li>\n<li>B<sup>2</sup>+A*(C+B)=C<sup>2</sup></li>\n<li>A<sup>2</sup>+C*(B-A)=B<sup>2</sup></li>\n</ul>\n<p>Als je wilt, worden ook deze drietallen worden doorgerekend.</p>"}︡
︠420e8a18-8d97-478c-bc74-7053bc81b41a︠
# Default bovengrens tot waar we abc-triples zoeken (o.a. handig voor testen)
NN = 400

# Om het programma sneller te laten zijn wordt eenmalig de lijst van mogelijke radialen bepaald
radiaal_range=[k for k in range(1,1000+1) if is_squarefree(k)]     #608 stuks

print radiaal_range[:80]
︡3b52bcc2-265e-4dc2-ad73-718fa2289ce8︡{"stdout": "[1, 2, 3, 5, 6, 7, 10, 11, 13, 14, 15, 17, 19, 21, 22, 23, 26, 29, 30, 31, 33, 34, 35, 37, 38, 39, 41, 42, 43, 46, 47, 51, 53, 55, 57, 58, 59, 61, 62, 65, 66, 67, 69, 70, 71, 73, 74, 77, 78, 79, 82, 83, 85, 86, 87, 89, 91, 93, 94, 95, 97, 101, 102, 103, 105, 106, 107, 109, 110, 111, 113, 114, 115, 118, 119, 122, 123, 127, 129, 130]"}︡
︠562ce8e1-2055-4229-ab5f-62ff66fad4db︠
#REKENPROGRAMMA's

#    Hulpfunctie om maximale exponent snel te bepalen
var('x,y')
f_exp=fast_callable(floor(log_b(x,y)+1),vars=[x,y],domain=float)

#----------------------------------------------------------------------------------------------------------

def mogelijk(reeks,maxum=400):

#    COMMENTAAR
#    We bepalen nu alle y =< maxum met y opgebouwd uit machten uit reeks

 if reeks in [[],[1]] or 1 in reeks: return [1]
 uitkomst=[1]
 for p in reeks: uitkomst=uitkomst+[k*p^e for k in uitkomst for e in xrange(1,int(f_exp(maxum//k,p)))]
 if maxum in uitkomst: return sorted(uitkomst[1:])[:-1]
 else: return sorted(uitkomst[1:])

#----------------------------------------------------------------------------------------------------------

def uitbreiding(triples):

#    COMMENTAAR
#    Een gevonden abc-triple a+b=c wordt vermenigvuldigd met (c+a),(c+b) of (b-a) om te zien of dat een #    nieuw abc drietal geeft. We gebruiken hier meer rekenwerk dan strikt noodzakelijk.

 uitkomst=[]
 for (p,q) in triples:
  b=max(p,q)
  a=min(p,q) 
  c=a+b
  if prod(prime_divisors(a*b*c*(b-a)))<b^2: uitkomst.append((a^2,(b-a)*c))
  if prod(prime_divisors(a*b*c*(c+a)))<c^2: uitkomst.append((a^2,(c+a)*b))
  if prod(prime_divisors(a*b*c*(c+b)))<c^2: uitkomst.append((b^2,(c+b)*a))
 return uitkomst

#----------------------------------------------------------------------------------------------------------

#HOOFDPROGRAMMA REKENEN

def abc_vinden(nmax):

#    COMMENTAAR
#    We bepalen nu in 5 stappen alle abc-triples. Getracht is effici gebruik te maken van wat we al
#    weten (i.h.b. r(y) en r(x)) en niet zaken opnieuw door te rekenen.

 abc_triples=[]
 ry=[k for k in radiaal_range if 1<k<isqrt(nmax)]                                 #stap 1
 for ny in ry: 
  yw=mogelijk(prime_divisors(ny),nmax)                                            #stap 2
  rx=[n for n in radiaal_range if 0<n<nmax/ny^2 and n<ny and gcd(n,ny)==1]        #stap 3
  for nx in rx:
   xw=mogelijk(prime_divisors(nx),nmax)                                           #stap 4
   for y in yw:
    for x in xw:
     #Geval x+y=c                                                                 #stap 5
     if nx*ny*prod(prime_divisors(x+y))<x+y: abc_triples.append((min(x,y),max(x,y)))
     #Geval |x-y|=a of b
     if nx*ny*prod(prime_divisors(abs(x-y)))<max(x,y): abc_triples.append((min(x,y),abs(x-y)))
 return uniq(abc_triples)
︡4f606df1-b93e-4810-9dc9-7c52076c756e︡︡
︠ed5b03b2-ddf5-4d05-83b3-ee60a92183d6︠
# TEST mogelijk

print mogelijk([2,3,5])
︡bf3e5ffb-d634-4580-a9a3-38db15a7769e︡{"stdout": "[2, 3, 4, 5, 6, 8, 9, 10, 12, 15, 16, 18, 20, 24, 25, 27, 30, 32, 36, 40, 45, 48, 50, 54, 60, 64, 72, 75, 80, 81, 90, 96, 100, 108, 120, 125, 128, 135, 144, 150, 160, 162, 180, 192, 200, 216, 225, 240, 243, 250, 256, 270, 288, 300, 320, 324, 360, 375, 384]"}︡
︠6407448e-644b-4ff9-b381-613a2857b7d4︠
# TEST uitbreiding

print uitbreiding([(1, 8), (1, 48), (1, 63), (1, 80), (5, 27), (8, 1), (27, 5), (32, 49)])
︡5312a8f6-c056-424a-b100-bd0490ddd2fa︡{"stdout": "[(1, 63), (1, 80), (1, 2303), (1, 2400), (1, 3968), (1, 4095), (1, 6399), (1, 6560), (6400, 161), (25, 704), (1, 63), (1, 80), (25, 704), (1024, 1377), (1024, 5537), (2401, 4160)]"}︡
︠175edd58-2a70-4dfe-8e29-86b6aafca282︠
# TEST abc_vinden

abc_vinden(100)
︡7af19056-e587-46e3-8749-d38f720b82ad︡{"stdout": "[(1, 8), (1, 48), (1, 63), (1, 80), (5, 27), (8, 1), (27, 5), (32, 49)]"}︡
︠67547814-d294-4f71-b7dd-f3659a2e8185︠
#PROGRAMMA's VOOR UITVOER

"""  COMMENTAAR 
     Deze routine is bijna gelijk aan het hoofdprogramma, en is vanwege de overzichtelijkheid apart
     gehouden. Anders zijn:
     - een begrenzing voor de zoekopdracht (anders teveel uitvoer)
     - printopdrachten voor elke stap
     - uitbreiding met de truc van Ismael Jimz Calvo
"""

#----------------------------------------------------------------------------------------------------------

def abc_stappen(nmax,stap):

#    COMMENTAAR
#    We bepalen nu (desgewenst) in 5 stappen alle abc-triples en geven extra analyse informatie

 [teller_ry,teller_yw,teller_rx,teller_xw,teller_abc]=[0]*5
 if stap>1: nmax=min(400,nmax)
 if nmax>400: nmax=400                                                            #Maximum gesteld
 print "r(y)<sqrt(%d) ofwel 1 < r(y) < %d"%(nmax,isqrt(nmax))                     #Extra informatie
 print ""
 abc_triples=[]
 ry=[k for k in radiaal_range if 1<k<isqrt(nmax)]                                 #stap 1
 teller_ry=len(ry)
 if stap>=1: print "1: Mogelijke radialen voor y:",ry," [r(y)]"
 for ny in ry:
  yw=mogelijk(prime_divisors(ny),nmax)                                            #stap 2
  teller_yw=teller_yw+len(yw)
  if stap>=2: print "2: Mogelijke y bij r(y)=%d:"%ny,yw
  rx=[n for n in radiaal_range if 0<n<nmax/ny^2 and n<ny and gcd(n,ny)==1]        #stap 3
  teller_rx=teller_rx+len(rx)
  if stap>=3: print "3: Mogelijke radialen voor x bij r(y)=%d:"%ny,rx
  for nx in rx:
   xw=mogelijk(prime_divisors(nx),nmax)                                           #stap 4
   teller_xw=teller_xw+len(xw)
   if stap>=4: print "4: Mogelijke x bij r(x)=%d:"%nx,xw
   for y in yw:
    for x in xw:
     #Geval x+y=c                                                                 #stap 5
     if nx*ny*prod(prime_divisors(x+y))<x+y: abc_triples.append((min(x,y),max(x,y)))
     #Geval |x-y|=a of b
     if nx*ny*prod(prime_divisors(abs(x-y)))<max(x,y): abc_triples.append((min(x,y),abs(x-y)))
     teller_abc=teller_abc+2
 print "" 
 return uniq(abc_triples),[teller_ry,teller_yw,teller_rx,teller_xw,teller_abc]

#----------------------------------------------------------------------------------------------------------
︡0c1750f6-562a-45d3-9dd4-b33adb384731︡︡
︠79ff6600-8f97-4d03-8435-cf653ef124c9︠
# TEST abc_stappen

(drietallen,[teller_ry,teller_yw,teller_rx,teller_xw,teller_abc])=abc_stappen(60,1)

print '#ry:',teller_ry,'#y:',teller_yw,'#rx:',teller_rx,'#x:',teller_xw,'#3-tallen:',teller_abc
print ''
print drietallen
︡a48a1ae5-9b65-41d7-9ded-3e89b94081f2︡{"stdout": "r(y)<sqrt(60) ofwel 1 < r(y) < 7\n\n1: Mogelijke radialen voor y: [2, 3, 5, 6]  [r(y)]\n\n#ry: 4 #y: 25 #rx: 6 #x: 14 #3-tallen: 100\n\n[(1, 8), (1, 48), (5, 27), (8, 1), (27, 5)]"}︡
︠22b7c498-6612-4c7f-96a6-75b650b2573e︠
# HOOFPRGRAMMA INVOER

html('<A name="start"></A>')

html('<h1>Invoer van parameters</h1>')


@interact

def intake(stap=input_box(default=1,label='Weergeven tot stap', width=1),nmax=input_box(default=NN,label='Invoer maximum (vanaf stap 2 beperkt tot 400)', width=2),alle_resultaten=("Alle resultaten weergeven?",True),uitbreiding_keuze=("Uitbreiding meenemen?",False),pythagoras_keuze=("Check of Pythagoras drietal?",False)):
      
   html('</>')
   (drietallen,[teller_ry,teller_yw,teller_rx,teller_xw,teller_abc])=abc_stappen(nmax,stap)
   print "Aantal r(y)      :",teller_ry
   print "Aantal y         :",teller_yw
   print "Aantal r(x)      :",teller_rx
   print "Aantal x         :",teller_xw
   print "Aantal drietallen:",teller_abc
   print "--------------"
   print drietallen
   print ""
   if uitbreiding_keuze: 
    print uitbreiding(drietallen)
    print ""
   if pythagoras_keuze: print "Pythagoras drietallen",[k for k in drietallen if k[0]^2+k[1]^2==(k[0]+k[1])^2]
   html('</>')
︡a36aa173-0159-4186-ba6b-5321cc68cf99︡︡
︠4a188dd1-0834-4cb5-b361-25078d4da282︠
###########
︡3566e078-cced-4e7e-a519-3875c7d8abde︡︡
